.386

.model flat, stdcall 
option casemap :none 

include \MASM32\INCLUDE\windows.inc
include \MASM32\INCLUDE\user32.inc
include \MASM32\INCLUDE\kernel32.inc
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\kernel32.lib

_DISK_EXTENT struct
  DiskNumber		DWORD ?
  StartingOffset	INT64 ?
  ExtentLength		INT64 ?
_DISK_EXTENT ends

_VOLUME_DISK_EXTENTS struct
  NumberOfDiskExtents	DWORD ?
  Extents		_DISK_EXTENT <>
_VOLUME_DISK_EXTENTS ends

.data
PhysicalDrive0	db '\\.\PhysicalDrive0',0
NumberD		db 'partition %u',0
form		db "error: %u", 0
perenos		db 13,10,0

.data?
buffer		db 512 dup(?)
string		db 1536 dup(?)
cw		dd ?
data1		_VOLUME_DISK_EXTENTS <>
		db 1024 dup (?)

.code
start:

invoke GetProcessHeap
mov edi, eax
invoke HeapAlloc, eax, HEAP_ZERO_MEMORY, 1024
mov esi, eax

invoke CreateFile,addr PhysicalDrive0,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ OR FILE_SHARE_WRITE,0, OPEN_EXISTING,0,0
mov ebx, eax

invoke DeviceIoControl, ebx, 5636096,0,0,esi,1024, addr cw, 0		;IOCTL_VOLUME_GET_VOLUME_DISK_EXTENTS,\
;invoke DeviceIoControl, ebx, 5636096,0,0,addr data1,sizeof data1, addr cw, 0
.if eax!=0
invoke wsprintf,ADDR buffer,addr NumberD, data1.NumberOfDiskExtents
.else
invoke GetLastError
invoke wsprintf,ADDR buffer,addr form, eax
.endif
invoke MessageBox,0,ADDR buffer,0,MB_ICONASTERISK
invoke CloseHandle, ebx

invoke HeapFree, edi,1,esi

invoke ExitProcess,0
end start